



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>spring boot使用TestRestTemplate集成测试 RESTful 接口</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">spring boot使用TestRestTemplate集成测试 RESTful 接口</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 03:54:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这篇文章没什么技术含量，只是单纯的记录一下如何用TestRestTemplate访问受security保护的api，供以后查阅。</p>
<div>
<pre class="prettyprint linenums">@Slf4j<br />
@RunWith(SpringRunner.class)<br />
@SpringBootTest(webEnvironment =     SpringBootTest.WebEnvironment.RANDOM_PORT)<br />
public class AccountControllerTests {<br />
    @Autowired<br />
    private TestRestTemplate restTemplate;<br />
    private HttpEntity httpEntity;

    /**<br />
     * 登录<br />
     * @throws Exception<br />
     */<br />
    private void login() throws Exception {<br />
        String expectStr = "{\"code\":0,\"msg\":\"success\"}";<br />
        MultiValueMap&lt;String, String&gt; map = new LinkedMultiValueMap&lt;&gt;();<br />
        map.add("username", "183xxxxxxxx");<br />
        map.add("password", "123456");<br />
        ResponseEntity responseEntity = restTemplate.postForEntity("/api/account/sign_in", map, String.class);<br />
        //添加cookie以保持状态<br />
        HttpHeaders headers = new HttpHeaders();<br />
        String headerValue = responseEntity.getHeaders().get("Set-Cookie").toString().replace("[", "");<br />
        headerValue = headerValue.replace("]", "");<br />
        headers.set("Cookie", headerValue);<br />
        httpEntity = new HttpEntity(headers);<br />
        assertThat(responseEntity.getBody()).isEqualTo(expectStr);<br />
    }

    /**<br />
     * 登出<br />
     * @throws Exception<br />
     */<br />
    private void logout() throws Exception {<br />
        String expectStr = "{\"code\":0,\"msg\":\"success\"}";<br />
        String result = restTemplate.postForObject("/api/account/sign_out", null, String.class, httpEntity);<br />
        httpEntity = null;<br />
        assertThat(result).isEqualTo(expectStr);<br />
    }

    /**<br />
     * 获取信息<br />
     * @throws Exception<br />
     */<br />
    private void getUserInfo() throws Exception {<br />
        Detail detail = new Detail();<br />
        detail.setNickname("疯狂的米老鼠");<br />
        detail.setNicknamePinyin("fengkuangdemilaoshu");<br />
        detail.setSex(1);<br />
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");<br />
        detail.setCreatedAt(sdf.parse("2017-11-03 16:43:27"));<br />
        detail.setUpdatedAt(sdf.parse("2017-11-03 16:43:27"));<br />
        Role role = new Role();<br />
        role.setName("ROLE_USER_NORMAL");<br />
        Set&lt;Role&gt; roles = new HashSet&lt;&gt;();<br />
        roles.add(role);<br />
        User user = new User();<br />
        user.setId(1L);<br />
        user.setPhone("183xxxxxxxx");<br />
        user.setEmail("xxxxxx@gmail.com");<br />
        user.setDetail(detail);<br />
        user.setRoles(roles);<br />
        ResultBean&lt;User&gt; resultBean = new ResultBean&lt;&gt;();<br />
        resultBean.setData(user);<br />
        ObjectMapper om = new ObjectMapper();<br />
        String expectStr = om.writeValueAsString(resultBean);<br />
        ResponseEntity&lt;String&gt; responseEntity = restTemplate.exchange("/api/user/get_user_info", HttpMethod.GET, httpEntity, String.class);<br />
        assertThat(responseEntity.getBody()).isEqualTo(expectStr);<br />
    }

    @Test<br />
    public void testAccount() throws Exception {<br />
        login();<br />
        getUserInfo();<br />
        logout();<br />
    }
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e4wve9.html">Leetcode-2 Add Two Numbers</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e0ereq.html">python更新后yum问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9311dg8.html">Url中處理空格、特殊字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvm5wjq.html">&lbrack;bzoj2124&rsqb;等差子序列&lpar;hash&plus;树状数组&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m15vp8.html">人生导师&mdash;&mdash;如何学习C&plus;&plus;的Windows方向</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yzml3q.html">osmocom-bb中用osmocon刷入固件命令那些参数你都弄懂了吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd53rr8.html">ddl语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnl432q.html">logstash开源日志收集查询分析系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmzexl9.html">生成MD5的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1drx79.html">spring中加入log4j</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z173w39.html">Python基础知识--列表和集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkrykv8.html">openstack-ocata-环境准备1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj05709.html">Docker学习系列（三）Docker搭建gitlab的两种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwpmny8.html">Kotlin入门&lpar;29&rpar;任务Runnable</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r561v4q.html">编译darknet出现libpng16&period;so&period;16：对&OpenCurlyQuote;inflateValidate&commat;ZLIB&lowbar;1&period;2&period;9&rsquo;未定义的引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q256k0vq.html">Redis缓存使用技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd4lwv9.html">线段树（segment tree）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy210x9.html">javascript面向对象精要第五章继承整理精要</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyz4on9.html">类的调用1（被调用的MyFirstJava）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2lodz9.html">linux lamp编译环境安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o15e6lq.html">net core体系-web应用程序-4asp&period;net core2&period;0 项目实战（1）-4项目前端说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll5y70q.html">Nginx的配置安装和使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv20x619.html">Python enum 枚举 判断 key（键） 或者 value（值）是否在枚举中</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1pyme9.html">fastadmin系统配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwz0oj9.html">POJ 3275 Ranking the Cows&lpar;传递闭包&rpar;【bitset优化Floyd】&plus;【领接表优化Floyd】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j120ww9.html">上海市2019年公务员录用考试第一轮首批面试名单&lpar;B类&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvrjrz8.html">visual studio 加入zen-codding</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj5en49.html">Word技巧【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2525nlq.html">web前端知识大纲：系列二 css篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r51ne7q.html">Scrapy基础&lpar;十二&rpar;&mdash;&mdash;&mdash;&mdash;异步导出Item数据到Mysql中</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
